CDECK  ID>, HWD2ME.
*CMZ :-        -09/04/02  13:37:38  by  Peter Richardson
*-- Author :    Peter Richardson
C-----------------------------------------------------------------------
      SUBROUTINE HWD2ME(IMODE)
C-----------------------------------------------------------------------
C     Computes the width and maximum weight for a two body mode
C-----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER IMODE,I
      DOUBLE PRECISION A(2),M(3),PCM,E1,E2,HWUPCM,PHS,WGT,MWGT,PCM2,
     &     M2(3)
      EXTERNAL HWUPCM
C--set up the masses and couplings
      M(1) = RMASS(IDK(ID2PRT(IMODE)))
      DO 1 I=1,2
      A(I)   = A2MODE(I,IMODE)
 1    M(I+1) = RMASS(IDKPRD(I,ID2PRT(IMODE)))
      DO 2 I=1,3
 2    M2(I)  = M(I)**2
C--first compute the masses etc
      PCM = HWUPCM(M(1),M(2),M(3))
      PCM2 = PCM**2
      PHS = PCM/M2(1)/8.0D0/PIFAC
C--now compute the width and max weight
C--first the fermion --> fermion scalar diagrams
      IF(I2DRTP(IMODE).EQ.1) THEN
        WGT = HALF*((A(1)**2+A(2)**2)*(M2(1)+M2(2)-M2(3))
     &              +FOUR*A(1)*A(2)*M(1)*M(2))
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT = HALF*M2(1)/(E1+E2)*(E1+PCM)*ABS(A(1)**2-A(2)**2)+WGT
C--next the fermion --> scalar fermion   diagrams
      ELSEIF(I2DRTP(IMODE).EQ.2) THEN
        WGT = HALF*((A(1)**2+A(2)**2)*(M2(1)+M2(3)-M2(2))
     &              +FOUR*A(1)*A(2)*M(1)*M(3))
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT = HALF*M2(1)/(E1+E2)*(E2+PCM)*ABS(A(1)**2-A(2)**2)+WGT
C--next the fermion --> scalar antifermion   diagrams
      ELSEIF(I2DRTP(IMODE).EQ.3) THEN
        WGT = HALF*((A(1)**2+A(2)**2)*(M2(1)+M2(3)-M2(2))
     &              +FOUR*A(1)*A(2)*M(1)*M(3))
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT = HALF*M2(1)/(E1+E2)*(E2+PCM)*ABS(A(1)**2-A(2)**2)+WGT
C--next the fermion --> fermion gauge boson diagrams
      ELSEIF(I2DRTP(IMODE).EQ.4) THEN
        WGT = 2.0D0*(M2(1)-M2(2))**2
        MWGT = WGT
C--next the scalar --> fermion antifermion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.5) THEN
        WGT = (M2(1)-M2(2)-M2(3))*(A(1)**2+A(2)**2)
     &        -FOUR*M(2)*M(3)*A(1)*A(2)
        MWGT = WGT
C--next the scalar --> fermion fermion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.6) THEN
        WGT = (M2(1)-M2(2)-M2(3))*(A(1)**2+A(2)**2)
     &        -FOUR*M(2)*M(3)*A(1)*A(2)
        MWGT = WGT
C--next the fermion --> fermion pion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.7) THEN
        WGT = HALF/FOUR/RMASS(198)**4*(
     &        (A(1)**2+A(2)**2)*((M2(1)-M2(2))**2-M2(3)*(M2(1)+M2(2)))
     &         +FOUR*M(1)*M(2)*M2(3)*A(1)*A(2))
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT =ONE/8.0D0/RMASS(198)**4*ABS(A(1)**2-A(2)**2)*
     &        M(1)*(M(1)*M2(3)+(M2(1)-M2(2)+M2(3))*(E2+PCM))+WGT
C--next scalar --> antifermion fermion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.8) THEN
        WGT = (M2(1)-M2(2)-M2(3))*(A(1)**2+A(2)**2)
     &        -FOUR*M(2)*M(3)*A(1)*A(2)
        MWGT = WGT
C--next fermion --> gravitino photon
      ELSEIF(I2DRTP(IMODE).EQ.9) THEN
        WGT = 8.0D0*M2(1)**3
        MWGT = WGT
C--next fermion --> gravitino scalar
      ELSEIF(I2DRTP(IMODE).EQ.10) THEN
        WGT = HALF*(M2(1)-M2(3))**3
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT = TWO*M2(1)/(E1+E2)*(E1+PCM)*(M2(1)-M2(3))**2 +WGT
C--next sfermion --> fermion gravitino
      ELSEIF(I2DRTP(IMODE).EQ.11) THEN
        WGT = (M2(1)-M2(2))**3
        MWGT = WGT
C--next antisfermion --> fermion gravitino
      ELSEIF(I2DRTP(IMODE).EQ.12) THEN
        WGT = (M2(1)-M2(2))**3
        MWGT = WGT
C--next the scalar --> antifermion antifermion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.13) THEN
        WGT = (M2(1)-M2(2)-M2(3))*(A(1)**2+A(2)**2)
     &        -FOUR*M(2)*M(3)*A(1)*A(2)
        MWGT = WGT
C--next the antifermion --> scalar antifermion diagrams
      ELSEIF(I2DRTP(IMODE).EQ.14) THEN
        WGT = HALF*((A(1)**2+A(2)**2)*(M2(1)+M2(3)-M2(2))
     &              +FOUR*A(1)*A(2)*M(1)*M(3))
        E1 = SQRT(M2(2)+PCM2)
        E2 = SQRT(M2(3)+PCM2)
        MWGT = HALF*M2(1)/(E1+E2)*(E2+PCM)*ABS(A(1)**2-A(2)**2)+WGT
C--unrecognised issue warning
      ELSE
        CALL HWWARN('HWITWO',500)
      ENDIF
      WGT  =       P2MODE(IMODE)* WGT*PHS
      MWGT = 1.1D0*P2MODE(IMODE)*MWGT*PHS
C--put the information in the common block
      WT2MAX(IMODE) = MWGT
C--output the information
      IF(IPRINT.GE.2) THEN
        WRITE(*,3010) WGT
        WRITE(*,3020) MWGT
        WRITE(*,3030) WGT/HBAR/BRFRAC(ID2PRT(IMODE))*
     &       RLTIM(IDK(ID2PRT(IMODE)))
      ENDIF
      RETURN
C--format statements
 3010 FORMAT('            PARTIAL WIDTH  = ',G12.4)
 3020 FORMAT('            MAXIMUM WEIGHT = ',E12.4)
 3030 FORMAT('     RATIO TO ISAJET VALUE = ',G12.4)
      END
