CDECK  ID>, HWHGUP.
*CMZ :-        -16/07/02  09.40.25  by  Peter Richardson
*-- Author :    Peter Richardson
C----------------------------------------------------------------------
      SUBROUTINE HWHGUP
C----------------------------------------------------------------------
C     Use the GUPI (Generic User Process Interface) event common block
C     as the hard process for HERWIG
C----------------------------------------------------------------------
#include "HERWIG65.INC"
C--Les Houches Common Block
      INTEGER MAXPUP
      PARAMETER(MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      DOUBLE PRECISION EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON /HEPRUP/ IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &                IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),
     &                XMAXUP(MAXPUP),LPRUP(MAXPUP)
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)
C--Local variables
      COMMON /HWGUP/ILOC(NMXHEP),JLOC(MAXNUP)
      INTEGER ILOC,JLOC,JHEP,ID,IPHO,LTRY
      INTEGER IHEP,IDIN(2),I,IDRES(2,MAXPUP),IRES,ICMF,ISTART,JRES,J
      COMMON/PHOCOM/XEPHO
      DOUBLE PRECISION PTEMP(5),XEPHO
      CHARACTER *8 DUMMY
      LOGICAL HWRLOG
      EXTERNAL HWRLOG
      IRES = 0
C--zero the variables
      DO I=1,NUP
         JLOC(I) = 0
      ENDDO
      DO I=1,NMXHEP
         ILOC(I) = 0
      ENDDO
c---generate hard subprocess
C--now do the event selection bit
      IF(.NOT.GENEV) THEN
        IDPRUP = LPRUP(ITYPLH)
        CALL UPEVNT
        IF(ABS(IDWTUP).EQ.1.OR.ABS(IDWTUP).EQ.2.OR.
     &     ABS(IDWTUP).EQ.4) THEN
          EVWGT = XWGTUP*1.0D-3
        ELSEIF(ABS(IDWTUP).EQ.3) THEN
          EVWGT = SIGN(ONE,XWGTUP)
        ELSE
          CALL HWWARN('HWHGUP',510)
        ENDIF
C--check the sign of the weight
        IF(IDWTUP.GT.ZERO.AND.EVWGT.LT.ZERO) CALL HWWARN('HWHGUP',520)
        RETURN
      ENDIF
C--update the number of events
      LHNEVT(ITYPLH) = LHNEVT(ITYPLH)+1
      ITYPLH = 0
C--first search to see if there are incoming beam particles in the record
      I = 0
      DO IHEP=1,NUP
        IF(ISTUP(IHEP).EQ.-9) THEN
          I=I+1
          IF(I.EQ.3) THEN
            CALL HWWARN('HWHGUP',102)
            GOTO 999
          ENDIF
          IDIN(I) = IHEP
        ENDIF
      ENDDO
C--put the beam particles in the record
C--require the soft event
      GENSOF = LHSOFT.AND.HWRLOG(PRSOF)
C--if given for event from event common block
      NHEP = 0
      IF(I.EQ.2) THEN
C--otherwise from the process common block
      ELSEIF(I.EQ.0) THEN
        DO I=1,2
          CALL HWUIDT(1,IDBMUP(I),IDHW(I),DUMMY)
          PHEP(1,I) = ZERO
          PHEP(2,I) = ZERO
          PHEP(4,I) = EBMUP(I)
          PHEP(5,I) = RMASS(IDHW(I))
          PHEP(3,I) = SQRT(EBMUP(I)**2-RMASS(IDHW(I))**2)
          ISTHEP(I) = 100+I
        ENDDO
        PHEP(3,2) = -PHEP(3,2)
        NHEP = NHEP+2
C--if not correct issue warning
      ELSE
        CALL HWWARN('HWHGUP',103)
        GOTO 999
      ENDIF
C--setup the centre-of-mass energy
      CALL HWVSUM(4,PHEP(1,NHEP-1),PHEP(1,NHEP),PHEP(1,NHEP+1))
      CALL HWUMAS(PHEP(1,NHEP+1))
      JMOHEP(1,NHEP+1) = NHEP-1
      JMOHEP(2,NHEP+1) = NHEP
      IDHW(3) = 14
      ISTHEP(3) = 103
      NHEP = NHEP+1
C--search for the incoming particles in collision
      I = 0
      DO IHEP=1,NUP
        IF(ISTUP(IHEP).EQ.-1) THEN
          I = I+1
          IF(I.EQ.3) THEN
            CALL HWWARN('HWHGUP',100)
            GOTO 999
          ENDIF
          IDIN(I) = IHEP
        ENDIF
      ENDDO
C--require two incoming particles
      IF(I.NE.2) THEN
        CALL HWWARN('HWHGUP',101)
        GOTO 999
      ENDIF
C--special for MC@NLO photoproduction
      IF (ABS(IDPRUP/100).EQ.51) THEN
         IF (IDUP(IDIN(1)).EQ.22) THEN
            IPHO=IDIN(1)
         ELSE
            IPHO=NUP+1
            CALL HWVZRO(5,PUP(1,IPHO))
            PUP(4,IPHO)=XEPHO
            PUP(3,IPHO)=PUP(4,IPHO)
         ENDIF
C--recompute cmf
         CALL HWVSUM(4,PHEP(1,2),PUP(1,IPHO),PHEP(1,NHEP))
            CALL HWUMAS(PHEP(1,NHEP))
            JMOHEP(1,NHEP)=NHEP+1
C--insert photon
         NHEP=NHEP+1
         CALL HWVEQU(5,PUP(1,IPHO),PHEP(1,NHEP))
         IDHEP(NHEP)=22
         CALL HWUIDT(1,IDHEP(NHEP),IDHW(NHEP),DUMMY)
         ISTHEP(NHEP)=3
         JMOHEP(1,NHEP)=1
         JDAHEP(1,1)=NHEP
C--insert outgoing beam particle
         NHEP=NHEP+1
         CALL HWVDIF(4,PHEP(1,1),PUP(1,IPHO),PHEP(1,NHEP))
         CALL HWUMAS(PHEP(1,NHEP))
         IDHEP(NHEP)=IDHEP(1)
         IDHW(NHEP)=IDHW(1)
         ISTHEP(NHEP)=1
         JMOHEP(1,NHEP)=1
         JDAHEP(2,1)=NHEP
      ENDIF
C--Now write incoming particles into the event record
      DO I=1,2
        IDHEP(NHEP+I) = IDUP(IDIN(I))
        ISTHEP(NHEP+I) = 110+I
        CALL HWUIDT(1,IDUP(IDIN(I)),IDHW(NHEP+I),DUMMY)
        CALL HWVEQU(5,PUP(1,IDIN(I)),PHEP(1,NHEP+I))
        JMOHEP(1,NHEP+I) = NHEP+3
        ILOC(NHEP+I) = IDIN(I)
        JLOC(I) = NHEP+I
C--special for particles which are identical to the beam
        DO J=1,2
          IF(IDHEP(NHEP+I).EQ.IDHEP(J)) THEN
            JDAHEP(1,J) = NHEP+I
            JDAHEP(2,J) = NHEP+I
          ENDIF
        ENDDO
      ENDDO
      CALL HWVSUM(4,PHEP(1,NHEP+1),PHEP(1,NHEP+2),PHEP(1,NHEP+3))
      CALL HWUMAS(PHEP(1,NHEP+3))
C--add the hard entry
      IDHW(NHEP+3) = 15
      IDHEP(NHEP+3)=0
      ISTHEP(NHEP+3) = 110
      JMOHEP(1,NHEP+3) = NHEP+1
      JMOHEP(2,NHEP+3) = NHEP+2
      JDAHEP(1,NHEP+3) = NHEP+4
      NHEP = NHEP+3
      ICMF = NHEP
C--now search for the outgoing particles and add them to the event record
      DO I=1,NUP
C--normal outgoing particles
        IF(ISTUP(I).EQ.1.AND.
     &        (MOTHUP(1,I).EQ.IDIN(1).OR.MOTHUP(1,I).EQ.IDIN(2))) THEN
          NHEP = NHEP+1
          IDHEP(NHEP) = IDUP(I)
          CALL HWUIDT(1,IDUP(I),IDHW(NHEP),DUMMY)
          CALL HWVEQU(5,PUP(1,I),PHEP(1,NHEP))
          JMOHEP(1,NHEP) = ICMF
          JMOHEP(2,NHEP) = 0
          JDAHEP(2,NHEP) = 0
          ILOC(NHEP) = I
          JLOC(I) = NHEP
C--resonances which must have mass preserved and resonances
C-- which don't have to have mass preserved
C--for the time being we won't disguish between these two options
        ELSEIF((ISTUP(I).EQ.2.OR.ISTUP(I).EQ.3).AND.
     &        (MOTHUP(1,I).EQ.IDIN(1).OR.MOTHUP(1,I).EQ.IDIN(2))) THEN
          NHEP = NHEP+1
          IDHEP(NHEP) = IDUP(I)
          CALL HWUIDT(1,IDUP(I),IDHW(NHEP),DUMMY)
          CALL HWVEQU(5,PUP(1,I),PHEP(1,NHEP))
          IRES = IRES+1
          IDRES(1,IRES) = NHEP
          IDRES(2,IRES) = I
          JMOHEP(1,NHEP) = ICMF
          JMOHEP(2,NHEP) = 0
          JDAHEP(2,NHEP) = 0
          ILOC(NHEP) = I
          JLOC(I) = NHEP
        ELSEIF(ISTUP(I).NE.-9.AND.ISTUP(I).NE.-1.AND.ISTUP(I).NE.1.AND.
     &         ISTUP(I).NE.2.AND.ISTUP(I).NE.3) THEN
          CALL HWWARN('HWHGUP',500)
        ENDIF
      ENDDO
C--Modified 2/7/03 for 2->1 processes
      IF(ICMF+1.EQ.NHEP) THEN
         NHEP = NHEP-1
         IDHEP(NHEP) = IDHEP(NHEP+1)
         IDHEP(NHEP+1) = 0
         IDHW(NHEP) = IDHW(NHEP+1)
         IDHW(NHEP+1) = 0
         CALL HWVEQU(5,PHEP(1,NHEP+1),PHEP(1,NHEP))
         JMOHEP(1,NHEP+1) = 0
         JMOHEP(2,NHEP+1) = 0
         JDAHEP(1,NHEP+1) = 0
         JDAHEP(2,NHEP+1) = 0
         JDAHEP(1,NHEP  ) = NHEP
         JDAHEP(2,NHEP  ) = NHEP
         ILOC(NHEP) = ILOC(NHEP+1)
         ILOC(NHEP+1) = 0
         JLOC(ILOC(NHEP)) = NHEP
         JLOC(NHEP+1) = 0
         DO I=1,IRES
            IF(IDRES(1,IRES).EQ.NHEP+1) IDRES(1,IRES) = NHEP
         ENDDO
      ELSE
         JDAHEP(2,ICMF) = NHEP
C--setup the status codes
         ISTHEP(ICMF+1) = 113
         DO IHEP=ICMF+2,NHEP
            ISTHEP(IHEP) = 114
         ENDDO
      ENDIF
C--End mod
      ISTART = ICMF-3
      EMSCA = SCALUP
C--generate parton shower
      CALL HWBGUP(ISTART,ICMF)
      IF (IERROR.NE.0) RETURN
C--now we need to sort out the resonances
      IF(IRES.EQ.0) RETURN
      JRES = 1
 35   ID = IDHEP(IDRES(1,JRES))
C--BRW fix to close ticket 51 caused problems: revert to Kluth solution
      LTRY=0
 36   IF(JDAHEP(1,IDRES(1,JRES)).NE.0.AND.
     &     JDAHEP(1,IDRES(1,JRES)).NE.IDRES(1,JRES)) THEN
        LTRY=LTRY+1
        IF (LTRY.GT.NSNTRY) THEN
           CALL HWWARN('HWHGUP',199)
           GOTO 999
        ENDIF
        IF(IDHEP(IDRES(1,JRES)).EQ.94) THEN
          DO IHEP=JDAHEP(1,IDRES(1,JRES)),JDAHEP(2,IDRES(1,JRES))
            IF(IDHEP(IHEP).EQ.ID) THEN
              IDRES(1,JRES) = IHEP
              GOTO 36
            ENDIF
          ENDDO
        ELSE
          IDRES(1,JRES) = JDAHEP(1,IDRES(1,JRES))
        ENDIF
        GOTO 36
      ENDIF
C--make a copy of this particle
      IHEP = IDRES(1,JRES)
      JMOHEP(1,NHEP+1) = JMOHEP(1,IDRES(1,JRES))
      JMOHEP(2,NHEP+1) = JMOHEP(2,IDRES(1,JRES))
      IDHEP(NHEP+1) = IDHEP(IDRES(1,JRES))
      IDHW(NHEP+1)  =  IDHW(IDRES(1,JRES))
      CALL HWVEQU(5,PHEP(1,IDRES(1,JRES)),PHEP(1,NHEP+1))
      IDRES(1,JRES) = NHEP+1
      JLOC(IDRES(2,JRES)) = IDRES(1,JRES)
      ISTHEP(NHEP+1) = 155
      NHEP = NHEP+1
C Reset colour pointers (if set)
      JHEP=JMOHEP(2,IHEP)
      IF (JHEP.GT.0) THEN
        IF (JDAHEP(2,JHEP).EQ.IHEP) JDAHEP(2,JHEP)=NHEP
        IF(.NOT.RPARTY.AND.ISTHEP(JHEP).EQ.155
     &    .AND.ABS(IDHEP(JHEP)).GT.1000000
     &    .AND.JDAHEP(2,JHEP-1).EQ.IHEP) JDAHEP(2,JHEP-1) = NHEP
      ENDIF
      JHEP=JDAHEP(2,IHEP)
      IF (JHEP.GT.0) THEN
        IF (JMOHEP(2,JHEP).EQ.IHEP) JMOHEP(2,JHEP)=NHEP
        IF(.NOT.RPARTY.AND.ISTHEP(JHEP).EQ.155
     &    .AND.ABS(IDHEP(JHEP)).GT.1000000
     &    .AND.JMOHEP(2,JHEP-1).EQ.IHEP) JMOHEP(2,JHEP-1) = NHEP
      ENDIF
C Relabel original track
      IF (ISTHEP(IHEP).NE.120) ISTHEP(IHEP)=3
      JMOHEP(2,IHEP)=JMOHEP(1,IHEP)
      JDAHEP(1,IHEP)=NHEP
      JDAHEP(2,IHEP)=NHEP
C--look for all the particles which have this as a mother
C--now search for the outgoing particles and add them to the event record
      JDAHEP(1,NHEP) = NHEP+1
      ISTHEP(NHEP+1) = 113
      DO I=1,NUP
        IF(ISTUP(I).EQ.1.AND.MOTHUP(1,I).EQ.IDRES(2,JRES)) THEN
          NHEP = NHEP+1
          IDHEP(NHEP) = IDUP(I)
          CALL HWUIDT(1,IDUP(I),IDHW(NHEP),DUMMY)
          CALL HWULOF(PUP(1,IDRES(2,JRES)),PUP(1,I),PHEP(1,NHEP))
          CALL HWULOB(PHEP(1,IDRES(1,JRES)),PHEP(1,NHEP),PHEP(1,NHEP))
          JMOHEP(1,NHEP) = IDRES(1,JRES)
          JMOHEP(2,NHEP) = 0
          JDAHEP(2,NHEP) = 0
          ILOC(NHEP) = I
          JLOC(I) = NHEP
        ELSEIF((ISTUP(I).EQ.2.OR.ISTUP(I).EQ.3).AND.
     &          MOTHUP(1,I).EQ.IDRES(2,JRES)) THEN
          NHEP = NHEP+1
          IDHEP(NHEP) = IDUP(I)
          CALL HWUIDT(1,IDUP(I),IDHW(NHEP),DUMMY)
          CALL HWULOF(PUP(1,IDRES(2,JRES)),PUP(1,I),PHEP(1,NHEP))
          CALL HWULOB(PHEP(1,IDRES(1,JRES)),PHEP(1,NHEP),PHEP(1,NHEP))
          IRES = IRES+1
          IDRES(1,IRES) = NHEP
          IDRES(2,IRES) = I
          JMOHEP(1,NHEP) = IDRES(1,JRES)
          JMOHEP(2,NHEP) = 0
          JDAHEP(2,NHEP) = 0
          ILOC(NHEP) = I
          JLOC(I) = NHEP
        ENDIF
      ENDDO
C--special for top decays to ensure b is second and W is first, this seems
C--to cause problems if the order is the other way around
      IF(ABS(IDHEP(IDRES(1,JRES))).EQ.6.AND.
     &     NHEP-IDRES(1,JRES).EQ.2) THEN
C--BW fix 01/08/12 (allows for non-b decays)
C        IF(ABS(IDHEP(NHEP-1)).EQ.5) THEN
        IF(ABS(IDHEP(NHEP-1)).LE.5) THEN
C--end fix
C--swap momenta
           CALL HWVEQU(5,PHEP(1,NHEP),PTEMP)
           CALL HWVEQU(5,PHEP(1,NHEP-1),PHEP(1,NHEP))
           CALL HWVEQU(5,PTEMP,PHEP(1,NHEP-1))
C--swap id's
           J = IDHW(NHEP)
           IDHW(NHEP) = IDHW(NHEP-1)
           IDHW(NHEP-1) = J
           J = IDHEP(NHEP)
           IDHEP(NHEP) = IDHEP(NHEP-1)
           IDHEP(NHEP-1) = J
C--locations
           J = ILOC(NHEP)
           ILOC(NHEP) = ILOC(NHEP-1)
           ILOC(NHEP-1) = J
           JLOC(ILOC(NHEP-1)) = NHEP-1
           JLOC(ILOC(NHEP))   = NHEP
C--resonances
           DO I=1,IRES
              IF(IDRES(1,I).EQ.NHEP) IDRES(1,I) = NHEP-1
           ENDDO
        ENDIF
      ENDIF
      DO IHEP=IDRES(1,JRES)+2,NHEP
        ISTHEP(IHEP) = 114
      ENDDO
      JDAHEP(2,IDRES(1,JRES)) = NHEP
      ISTART = IDRES(1,JRES)
C--BRW mod 21/11/06 for pt-veto
      IF (.NOT.PTVETO) EMSCA = PHEP(4,IDRES(1,JRES))
      CALL HWBGUP(ISTART,0)
      IF (IERROR.NE.0) RETURN
      IF(JRES.NE.IRES) THEN
        JRES = JRES+1
        GOTO 35
      ENDIF
 999  RETURN
      END
